blob: 3b261b0f74f0a7609dafbea36a19c647062ce8d9 [file] [log] [blame]
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02001#!/bin/sh
Greg Kroah-Hartmanb2441312017-11-01 15:07:57 +01002# SPDX-License-Identifier: GPL-2.0
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02003#
4# link vmlinux
5#
Masahiro Yamadad151e972019-01-17 09:10:04 +09006# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020011#
12# vmlinux
13# ^
14# |
Masahiro Yamadad151e972019-01-17 09:10:04 +090015# +--< $(KBUILD_VMLINUX_OBJS)
16# | +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020017# |
Nicholas Piggin3a166fc2017-06-20 01:52:05 +100018# +--< $(KBUILD_VMLINUX_LIBS)
19# | +--< lib/lib.a + more
20# |
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020021# +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
Masahiro Yamada3ec8a5b2020-07-02 04:29:36 +090033LD="$1"
34KBUILD_LDFLAGS="$2"
35LDFLAGS_vmlinux="$3"
36
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020037# Nice output in kbuild format
38# Will be supressed by "make -s"
39info()
40{
41 if [ "${quiet}" != "silent_" ]; then
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -070042 printf " %-7s %s\n" "${1}" "${2}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020043 fi
44}
45
Sami Tolvanen110784e2017-12-08 15:49:24 -080046# Generate a linker script to ensure correct ordering of initcalls.
47gen_initcalls()
48{
49 info GEN .tmp_initcalls.lds
50
51 ${PYTHON} ${srctree}/scripts/jobserver-exec \
52 ${PERL} ${srctree}/scripts/generate_initcall_order.pl \
53 ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS} \
54 > .tmp_initcalls.lds
55}
56
Sami Tolvanen93f38312020-03-06 14:19:09 -080057# If CONFIG_LTO_CLANG is selected, collect generated symbol versions into
58# .tmp_symversions.lds
59gen_symversions()
60{
61 info GEN .tmp_symversions.lds
62 rm -f .tmp_symversions.lds
63
64 for o in ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}; do
65 if [ -f ${o}.symversions ]; then
66 cat ${o}.symversions >> .tmp_symversions.lds
67 fi
68 done
69}
70
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020071# Link of vmlinux.o used for section mismatch analysis
72# ${1} output file
73modpost_link()
74{
Stephen Rothwella5967db2016-08-24 22:29:19 +100075 local objects
Sami Tolvanen93f38312020-03-06 14:19:09 -080076 local lds=""
Stephen Rothwella5967db2016-08-24 22:29:19 +100077
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100078 objects="--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +090079 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100080 --no-whole-archive \
81 --start-group \
82 ${KBUILD_VMLINUX_LIBS} \
83 --end-group"
84
Sami Tolvanenba01e932020-03-06 14:14:03 -080085 if [ -n "${CONFIG_LTO_CLANG}" ]; then
Sami Tolvanen110784e2017-12-08 15:49:24 -080086 gen_initcalls
87 lds="-T .tmp_initcalls.lds"
88
Sami Tolvanen93f38312020-03-06 14:19:09 -080089 if [ -n "${CONFIG_MODVERSIONS}" ]; then
90 gen_symversions
91 lds="${lds} -T .tmp_symversions.lds"
92 fi
93
Sami Tolvanenba01e932020-03-06 14:14:03 -080094 # This might take a while, so indicate that we're doing
95 # an LTO link
96 info LTO ${1}
97 else
98 info LD ${1}
99 fi
100
Sami Tolvanen93f38312020-03-06 14:19:09 -0800101 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${lds} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200102}
103
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100104objtool_link()
105{
Sami Tolvanen6dd43b92020-04-13 16:10:13 -0700106 local objtoolcmd;
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100107 local objtoolopt;
108
Sami Tolvanen6dd43b92020-04-13 16:10:13 -0700109 if [ "${CONFIG_LTO_CLANG} ${CONFIG_STACK_VALIDATION}" = "y y" ]; then
110 # Don't perform vmlinux validation unless explicitly requested,
111 # but run objtool on vmlinux.o now that we have an object file.
112 if [ -n "${CONFIG_UNWINDER_ORC}" ]; then
113 objtoolcmd="orc generate"
114 fi
115
116 objtoolopt="${objtoolopt} --duplicate"
117
118 if [ -n "${CONFIG_FTRACE_MCOUNT_USE_OBJTOOL}" ]; then
119 objtoolopt="${objtoolopt} --mcount"
120 fi
121 fi
122
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100123 if [ -n "${CONFIG_VMLINUX_VALIDATION}" ]; then
Sami Tolvanen6dd43b92020-04-13 16:10:13 -0700124 objtoolopt="${objtoolopt} --noinstr"
125 fi
126
127 if [ -n "${objtoolopt}" ]; then
128 if [ -z "${objtoolcmd}" ]; then
129 objtoolcmd="check"
130 fi
131 objtoolopt="${objtoolopt} --vmlinux"
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100132 if [ -z "${CONFIG_FRAME_POINTER}" ]; then
133 objtoolopt="${objtoolopt} --no-fp"
134 fi
Sami Tolvanen6dd43b92020-04-13 16:10:13 -0700135 if [ -n "${CONFIG_GCOV_KERNEL}" ] || [ -n "${CONFIG_LTO_CLANG}" ]; then
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100136 objtoolopt="${objtoolopt} --no-unreachable"
137 fi
138 if [ -n "${CONFIG_RETPOLINE}" ]; then
139 objtoolopt="${objtoolopt} --retpoline"
140 fi
141 if [ -n "${CONFIG_X86_SMAP}" ]; then
142 objtoolopt="${objtoolopt} --uaccess"
143 fi
144 info OBJTOOL ${1}
Sami Tolvanen6dd43b92020-04-13 16:10:13 -0700145 tools/objtool/objtool ${objtoolcmd} ${objtoolopt} ${1}
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100146 fi
147}
148
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200149# Link of vmlinux
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700150# ${1} - output file
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700151# ${2}, ${3}, ... - optional extra .o files
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200152vmlinux_link()
153{
154 local lds="${objtree}/${KBUILD_LDS}"
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700155 local output=${1}
Stephen Rothwella5967db2016-08-24 22:29:19 +1000156 local objects
Kees Cookaf73d782020-03-03 18:18:34 -0800157 local strip_debug
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200158
Linus Torvaldsd7b08272019-09-20 08:36:47 -0700159 info LD ${output}
160
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700161 # skip output file argument
162 shift
163
Kees Cookaf73d782020-03-03 18:18:34 -0800164 # The kallsyms linking does not need debug symbols included.
165 if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
166 strip_debug=-Wl,--strip-debug
167 fi
168
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200169 if [ "${SRCARCH}" != "um" ]; then
Sami Tolvanenba01e932020-03-06 14:14:03 -0800170 if [ -n "${CONFIG_LTO_CLANG}" ]; then
171 # Use vmlinux.o instead of performing the slow LTO
172 # link again.
173 objects="--whole-archive \
174 vmlinux.o \
175 --no-whole-archive \
176 ${@}"
177 else
178 objects="--whole-archive \
179 ${KBUILD_VMLINUX_OBJS} \
180 --no-whole-archive \
181 --start-group \
182 ${KBUILD_VMLINUX_LIBS} \
183 --end-group \
184 ${@}"
185 fi
Stephen Rothwella5967db2016-08-24 22:29:19 +1000186
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700187 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux} \
Kees Cookaf73d782020-03-03 18:18:34 -0800188 ${strip_debug#-Wl,} \
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700189 -o ${output} \
Stephen Rothwella5967db2016-08-24 22:29:19 +1000190 -T ${lds} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200191 else
Nicholas Piggin6358d6e2018-02-11 00:25:03 +1000192 objects="-Wl,--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +0900193 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +1000194 -Wl,--no-whole-archive \
195 -Wl,--start-group \
196 ${KBUILD_VMLINUX_LIBS} \
197 -Wl,--end-group \
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700198 ${@}"
Stephen Rothwella5967db2016-08-24 22:29:19 +1000199
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700200 ${CC} ${CFLAGS_vmlinux} \
Kees Cookaf73d782020-03-03 18:18:34 -0800201 ${strip_debug} \
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700202 -o ${output} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +1000203 -Wl,-T,${lds} \
204 ${objects} \
Stephen Rothwella5967db2016-08-24 22:29:19 +1000205 -lutil -lrt -lpthread
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200206 rm -f linux
207 fi
208}
209
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700210# generate .BTF typeinfo from DWARF debuginfo
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700211# ${1} - vmlinux image
212# ${2} - file to dump raw BTF data into
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700213gen_btf()
214{
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700215 local pahole_ver
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700216
Andrii Nakryiko581b31c2019-05-05 17:10:33 -0700217 if ! [ -x "$(command -v ${PAHOLE})" ]; then
Chris Down2a67a6c2020-01-22 00:01:10 +0000218 echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700219 return 1
Andrii Nakryiko581b31c2019-05-05 17:10:33 -0700220 fi
221
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700222 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
Lorenz Bauer21a85bd2020-06-08 10:42:57 +0100223 if [ "${pahole_ver}" -lt "116" ]; then
224 echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700225 return 1
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700226 fi
227
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700228 vmlinux_link ${1}
Kees Cookaf73d782020-03-03 18:18:34 -0800229
230 info "BTF" ${2}
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700231 LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${1}
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700232
Fangrui Song90ceddc2020-03-18 15:27:46 -0700233 # Create ${2} which contains just .BTF section but no symbols. Add
234 # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
235 # deletes all symbols including __start_BTF and __stop_BTF, which will
236 # be redefined in the linker script. Add 2>/dev/null to suppress GNU
237 # objcopy warnings: "empty loadable segment detected at ..."
238 ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
239 --strip-all ${1} ${2} 2>/dev/null
240 # Change e_type to ET_REL so that it can be used to link final vmlinux.
241 # Unlike GNU ld, lld does not allow an ET_EXEC input.
242 printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700243}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200244
Masahiro Yamada08beb662020-09-25 00:45:46 +0900245# Create ${2} .S file with all symbols from the ${1} object file
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200246kallsyms()
247{
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200248 local kallsymopt;
249
250 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
James Hogan6895f972012-09-06 22:11:25 +0100251 kallsymopt="${kallsymopt} --all-symbols"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200252 fi
253
Ard Biesheuvel4d5d5662016-03-15 14:58:12 -0700254 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
Rusty Russellc6bda7c2014-03-17 14:05:46 +1030255 kallsymopt="${kallsymopt} --absolute-percpu"
256 fi
257
Ard Biesheuvel2213e9a2016-03-15 14:58:19 -0700258 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
259 kallsymopt="${kallsymopt} --base-relative"
260 fi
261
Masahiro Yamada08beb662020-09-25 00:45:46 +0900262 info KSYMS ${2}
263 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${2}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200264}
265
Kees Cook8959e392019-08-13 08:15:32 -0700266# Perform one step in kallsyms generation, including temporary linking of
267# vmlinux.
268kallsyms_step()
269{
270 kallsymso_prev=${kallsymso}
Kees Cookaf73d782020-03-03 18:18:34 -0800271 kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
272 kallsymso=${kallsyms_vmlinux}.o
Masahiro Yamada08beb662020-09-25 00:45:46 +0900273 kallsyms_S=${kallsyms_vmlinux}.S
Kees Cook8959e392019-08-13 08:15:32 -0700274
Linus Torvaldsd7b08272019-09-20 08:36:47 -0700275 vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
Masahiro Yamada08beb662020-09-25 00:45:46 +0900276 kallsyms ${kallsyms_vmlinux} ${kallsyms_S}
277
278 info AS ${kallsyms_S}
279 ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
280 ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
281 -c -o ${kallsymso} ${kallsyms_S}
Kees Cook8959e392019-08-13 08:15:32 -0700282}
283
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200284# Create map file with all symbols from ${1}
285# See mksymap for additional details
286mksysmap()
287{
288 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
289}
290
Shile Zhang10916702019-12-04 08:46:31 +0800291sorttable()
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700292{
Shile Zhang10916702019-12-04 08:46:31 +0800293 ${objtree}/scripts/sorttable ${1}
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700294}
295
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200296# Delete output files in case of error
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200297cleanup()
298{
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700299 rm -f .btf.*
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200300 rm -f .tmp_System.map
Sami Tolvanen110784e2017-12-08 15:49:24 -0800301 rm -f .tmp_initcalls.lds
Sami Tolvanen93f38312020-03-06 14:19:09 -0800302 rm -f .tmp_symversions.lds
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200303 rm -f .tmp_vmlinux*
304 rm -f System.map
305 rm -f vmlinux
306 rm -f vmlinux.o
307}
308
Sylvain BERTRANDab160db2015-05-07 00:36:04 +0000309on_exit()
310{
311 if [ $? -ne 0 ]; then
312 cleanup
313 fi
314}
315trap on_exit EXIT
316
317on_signals()
318{
319 exit 1
320}
321trap on_signals HUP INT QUIT TERM
322
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200323# Use "make V=1" to debug this script
324case "${KBUILD_VERBOSE}" in
325*1*)
326 set -x
327 ;;
328esac
329
330if [ "$1" = "clean" ]; then
331 cleanup
332 exit 0
333fi
334
335# We need access to CONFIG_ symbols
Masahiro Yamada94cf8ac2019-03-08 14:49:10 +0900336. include/config/auto.conf
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200337
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200338# Update version
339info GEN .version
Masahiro Yamada278ae602017-09-22 14:31:13 +0900340if [ -r .version ]; then
341 VERSION=$(expr 0$(cat .version) + 1)
342 echo $VERSION > .version
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200343else
Masahiro Yamada278ae602017-09-22 14:31:13 +0900344 rm -f .version
345 echo 1 > .version
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200346fi;
347
348# final build of init/
Masahiro Yamada083bc0e2020-02-11 05:06:34 +0900349${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200350
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100351#link vmlinux.o
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100352modpost_link vmlinux.o
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100353objtool_link vmlinux.o
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100354
355# modpost vmlinux.o to check for section mismatches
Masahiro Yamadaa7215882019-07-31 00:59:02 +0900356${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100357
Alexey Gladkov898490c2019-04-29 18:11:14 +0200358info MODINFO modules.builtin.modinfo
359${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
Masahiro Yamada8b41fc42019-12-19 17:33:29 +0900360info GEN modules.builtin
361# The second line aids cases where multiple modules share the same object.
362tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
363 tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
Alexey Gladkov898490c2019-04-29 18:11:14 +0200364
Andrii Nakryiko7fd78562019-08-13 11:54:42 -0700365btf_vmlinux_bin_o=""
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700366if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
Kees Cookaf73d782020-03-03 18:18:34 -0800367 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
368 if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
Stanislav Fomichevda5fb182019-11-27 08:14:10 -0800369 echo >&2 "Failed to generate BTF for vmlinux"
370 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
371 exit 1
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700372 fi
373fi
374
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200375kallsymso=""
Kees Cook8959e392019-08-13 08:15:32 -0700376kallsymso_prev=""
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200377kallsyms_vmlinux=""
378if [ -n "${CONFIG_KALLSYMS}" ]; then
379
380 # kallsyms support
381 # Generate section listing all symbols and add it into vmlinux
382 # It's a three step process:
383 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
384 # but __kallsyms is empty.
385 # Running kallsyms on that gives us .tmp_kallsyms1.o with
386 # the right size
387 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
388 # the right size, but due to the added section, some
389 # addresses have shifted.
390 # From here, we generate a correct .tmp_kallsyms2.o
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100391 # 3) That link may have expanded the kernel image enough that
392 # more linker branch stubs / trampolines had to be added, which
393 # introduces new names, which further expands kallsyms. Do another
394 # pass if that is the case. In theory it's possible this results
395 # in even more stubs, but unlikely.
396 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
397 # other bugs.
398 # 4) The correct ${kallsymso} is linked into the final vmlinux.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200399 #
400 # a) Verify that the System.map from vmlinux matches the map from
401 # ${kallsymso}.
402
Kees Cook8959e392019-08-13 08:15:32 -0700403 kallsyms_step 1
404 kallsyms_step 2
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200405
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100406 # step 3
Kees Cook8959e392019-08-13 08:15:32 -0700407 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
408 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100409
410 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
Kees Cook8959e392019-08-13 08:15:32 -0700411 kallsyms_step 3
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200412 fi
413fi
414
Linus Torvaldsd7b08272019-09-20 08:36:47 -0700415vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700416
Jiri Olsac9a0f3b2020-07-11 23:53:24 +0200417# fill in BTF IDs
Jiri Olsa017dab32020-09-23 20:57:34 +0200418if [ -n "${CONFIG_DEBUG_INFO_BTF}" -a -n "${CONFIG_BPF}" ]; then
419 info BTFIDS vmlinux
420 ${RESOLVE_BTFIDS} vmlinux
Jiri Olsac9a0f3b2020-07-11 23:53:24 +0200421fi
422
Shile Zhang10916702019-12-04 08:46:31 +0800423if [ -n "${CONFIG_BUILDTIME_TABLE_SORT}" ]; then
424 info SORTTAB vmlinux
Shile Zhangf14bf6a2019-12-04 08:46:33 +0800425 if ! sorttable vmlinux; then
426 echo >&2 Failed to sort kernel tables
427 exit 1
428 fi
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700429fi
430
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200431info SYSMAP System.map
432mksysmap vmlinux System.map
433
434# step a (see comment above)
435if [ -n "${CONFIG_KALLSYMS}" ]; then
436 mksysmap ${kallsyms_vmlinux} .tmp_System.map
437
438 if ! cmp -s System.map .tmp_System.map; then
Michal Marek5369f552012-07-07 23:04:40 +0200439 echo >&2 Inconsistent kallsyms data
Michal Marek367e43c2012-08-10 11:55:11 +0200440 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200441 exit 1
442 fi
443fi